# -*- coding: utf-8 -*-

from __future__ import division 
import es
import cPickle
import gamethread
from random import choice as rChoice
from os.path import isfile
from popuplib import easymenu
from configobj import ConfigObj
from playerlib import getPlayer
from nativetools import spawnPlayer, switchTeam
from usermsg import showVGUIPanel

player = {}
sounds = ['radiotaunts08', 'radiotaunts02', 'radiotaunts04']
start_sounds = ['roundstart02', 'roundstart04', 'roundstart05']
end_sounds = ['roundend01', 'roundend06', 'roundend07']
death_hidden = ['death01', 'death05']
scary_sounds = ['imhere01', 'overhere02', 'turnaround02']
answers_iris = ['ragealert02', 'ragealert04', 'ragealert05']
death_iris = ['death14', 'death04']
model = 'models/player/elis/hd/hidden.mdl'

class Configuration(object):
    def __init__(self):
        self.cfgfile = es.getAddonPath('hidden') + '/hidden_config.ini'
    def getFile(self):
        return ConfigObj(self.cfgfile)
config = Configuration()

class Player(object):
    def __init__(self, userid):
        self.userid = userid
        self.roundkills = self._class = self.prim = self.sec = self.addition = self.class_time = self.oldName = 0
    def fire(self, cmd):
        es.server.queuecmd('es_xfire %s %s' % (self.userid, cmd))
    def give(self, cmd):
        es.server.queuecmd('es_xgive %s %s' % (self.userid, cmd))
    def strip(self, knife=True):
        self.fire('player_weaponstrip kill')
        self.give('player_weaponstrip')
        self.fire('player_weaponstrip strip')
        gamethread.delayed(0, self.give, 'item_assaultsuit')
        if knife:
            gamethread.delayed(0, self.give, 'weapon_knife')
    def funcs(self, arg):
        arg = arg.capitalize()
        self.fire('func_buyzone %s' % arg)
        self.fire('func_bomb_target %s' % arg)
        self.fire('func_hostage_rescue %s' % arg)
    def switch(self, team, _userid=False, _spawn=True, god=False):
        uid = _userid if _userid else self.userid
        switchTeam(int(uid), team)
        if _spawn:
            gamethread.delayed(0, spawnPlayer, (uid, True))
        if god:
            es.setplayerprop(self.userid, 'CBasePlayer.m_lifeState', 0)
    def playScary(self):
        es.cexec_all('play', 'hidden/617-%s.mp3' % rChoice(scary_sounds))
        gamethread.delayed(4, es.cexec_all, ('play', 'hidden/IRIS-%s.wav' % rChoice(answers_iris)))
        gamethread.delayedname(30, 'scary', self.playScary)
    def spawn(self, team):
        player = getPlayer(self.userid)
        cfg = config.getFile()['hidden']
        hiddens = int(cfg['count'])
        _s = 'ONE #greenHidden'
        if hiddens > 1:
            _s = '%s #greenHiddens' % hiddens
        es.setplayerprop(self.userid, 'CBasePlayer.m_lifeState', 512)
        self.funcs('disable')
        self.strip()
        if team == 2:
            if es.getplayercount(2) > hiddens:
                es.tell(self.userid, '#green[#lightgreenES Hidden#green] #defaultThere can only be #lightgreen%s' % _s)
                self.switch(3, _spawn=True)
            else:
                health = float(cfg['health'])
                es.setplayerprop(self.userid, 'CBasePlayer.m_iHealth', health)
                es.setplayerprop(self.userid, 'CBasePlayer.localdata.m_flLaggedMovementValue', float(cfg['speed']))
                player.set('color', (255, 255, 255, 19))
                #gamethread.delayed(0, self.setModel)
                if self.roundkills:
                    add = float(cfg['additional_health'])
                    health = health + add
                    _s = '1 #greenIRIS Force'
                    if self.roundkills > 1:
                        health = health + (add * self.roundkills)
                        _s = '%s #greenIRIS Forces' % self.roundkills
                    es.setplayerprop(self.userid, 'CBasePlayer.m_iHealth', health)
                    es.tell(self.userid, '#multi', '#green[#lightgreenES Hidden#green] #defaultYou get #green%s #lightgreenHP #defaultfor killing #lightgreen%s' % (str(health).replace('.0', ''), _s))
                    self.roundkills = 0
                gamethread.delayedname(30, 'scary', self.playScary)
        elif team == 3:
            if es.getplayercount(2) < hiddens:
                es.tell(self.userid, '#green[#lightgreenES Hidden#green] #defaultThere must be #lightgreen%s' % _s)
                self.switch(2, _spawn=True, god=True)
            else:
                player.set('color', (255, 255, 255, 255))
                es.tell(self.userid, '#multi', '#green[#lightgreenES Hidden#green] #defaultType #lightgreen!class #defaultto change your class.')
                if es.getplayersteamid(self.userid) == 'BOT':
                    gamethread.delayed(0, self.give, 'weapon_%s' % rChoice(config.getFile()['iris']['bot_sec']))
                    gamethread.delayed(0, self.give, 'weapon_%s' % rChoice(config.getFile()['iris']['bot_prim']))
                else:
                    self.class_time = 0
                    if self._class:
                        hp = 125
                        if self._class == 'assault':
                            hp = 50 if self.prim == 'm4a1' else 75
                        es.setplayerprop(self.userid, 'CBasePlayer.m_iHealth', hp)
                        gamethread.delayed(.1, self.additions)
                        gamethread.delayed(.1, self.give, 'weapon_%s' % self.sec)
                        gamethread.delayed(.1, self.give, 'weapon_%s' % self.prim)
                    else:
                        gamethread.delayed(0, choose.send, self.userid)
    def endRound(self, winner):
        if winner in [2, 3]:
            text = 'WINS'
            if winner == 3:
                gamethread.delayed(.5, es.cexec_all, ('play', 'hidden/IRIS-%s.wav' % rChoice(end_sounds)))
                text = 'NEUTRALIZED'
            es.centermsg('Subject 617')
            gamethread.delayed(1.3, es.centermsg, text)
        es.setplayerprop(self.userid, 'CBasePlayer.m_lifeState', 0)
        self.strip(knife=False)
        gamethread.cancelDelayed('scary')
    def death(self, userid):
        uteam = es.getplayerteam(userid)
        ateam = es.getplayerteam(self.userid)
        cfg = config.getFile()['hidden']
        if uteam == 2 and ateam == 3:
            es.cexec(self.userid, 'hidden/617-%s.mp3' % rChoice(death_hidden))
            hiddens = int(cfg['count'])
            self.switch(3, _userid=userid, _spawn=True)
            self.switch(2, _userid=False, _spawn=False, god=True)
            _s = 'the' if hiddens == 1 else 'a'
            es.msg('#multi', '#green[#lightgreenES Hidden#green] %s #defaultis now %s #greenHidden' % (es.getplayername(self.userid), _s))
            if hiddens > 1 and es.getlivingplayercount(2):
                gamethread.delayed(.75, spawnPlayer, userid)
                gamethread.delayed(.75, spawnPlayer, self.userid)
        elif uteam == 3 and ateam == 2:
            self.roundkills += 1
            add = float(cfg['additional_health'])
            speed = es.getplayerprop(self.userid, 'CBasePlayer.localdata.m_flLaggedMovementValue')
            es.setplayerprop(self.userid, 'CBasePlayer.localdata.m_flLaggedMovementValue', float(speed) + float(cfg['extra_speed']))
            es.setplayerprop(self.userid, 'CBasePlayer.m_iHealth', int(es.getplayerprop(self.userid, 'CBasePlayer.m_iHealth')) + add)
            es.cexec(self.userid, 'playgamesound', 'items/smallmedkit1.wav')
            es.cexec(userid, 'playgamesound', 'hidden/IRIS-%s.wav' % rChoice(death_iris))
            es.msg('#multi', '#green[#lightgreenES Hidden#green] Hidden #lightgreen%s #defaultgot #green%s #lightgreenHP #defaultfor killing #green%s' % (es.getplayername(self.userid), str(add).replace('.0', ''), es.getplayername(userid)))
            gamethread.delayed(1, es.cexec_all, ('play', 'hidden/%s%s.mp3' % (rChoice(['IRIS-617', '617-']), rChoice(sounds))))
    def setCTime(self):
        self.class_time = 0
    def getClass(self):
        if es.getplayerteam(self.userid) == 3:
            _time = float(config.getFile()['iris']['class_time'])
            if not self.class_time:
                self.strip()
                choose.send(self.userid)
                self.class_time = 1
                gamethread.delayed(_time, self.setCTime)
            else:
                es.tell(self.userid, '#multi', '#green[#lightgreenES Hidden#green] #defaultYou can only change your class within #lightgreen%s #defaultseconds!' % _time)
        else:
            es.tell(self.userid, '#multi', "#green[#lightgreenES Hidden#green] Hidden #lightgreencan't change its class!")
    def _choose(self, choice):
        self._class = choice
        if choice == 'assault':
            assault.send(self.userid)
        else:
            support.send(self.userid)
    def _assault(self, choice):
        self.prim = choice
        addition.send(self.userid)
    def _support(self, choice):
        self.prim = choice
        addition.send(self.userid)
    def _sec(self, choice):
        self.sec = choice
        self.strip()
        gamethread.delayed(0, self.giveWeapons)
    def _addition(self, choice):
        self.addition = choice
        sec.send(self.userid)
    def giveWeapons(self):
        hp = 125
        if self._class == 'assault':
            hp = 50 if self.prim == 'm4a1' else 75
        es.setplayerprop(self.userid, 'CBasePlayer.m_iHealth', hp)
        self.give('weapon_%s' % self.sec)
        self.give('weapon_%s' % self.prim)
        self.additions()
    def additions(self):
        if self.addition == 'nvgs':
            self.nvgs()
        elif self.addition in ['hegrenade', 'flashbang']:
            self.give('weapon_%s' % self.addition)
            if self.addition == 'hegrenade':
                self.nvgs()
    def nvgs(self):
        self.give('item_nvgs')
        if int(config.getFile()['general']['dark_mode']) == 2:
            gamethread.delayed(0, es.setplayerprop, (self.userid, 'CCSPlayer.m_bNightVisionOn', 1))
        es.tell(self.userid, '#multi', '#green[#lightgreenHidden#green] #defaultPress #greenN #defaultto de-/activate the #lightgreenLight Amplification Goggles (NVGs)')

def load():
    global choose, sec, support, assault, addition
    es.ServerVar('hidden_ver', '4.0 ESP').makepublic()
    choose = easymenu('hidden_choose_class', '_popup_choice', Choose)
    choose.settitle('Assault or Support?')
    choose.setdescription('Assault: Powerful Weapons, less HP\nSupport: Less powerful Weapons, more HP')
    choose.addoption('assault', '[√] Assault')
    choose.addoption('support', '[√] Support')
    assault = easymenu('hidden_assault', '_popup_choice', Assault)
    assault.settitle('[√] Assault')
    assault.setdescription('M4A1 Carbine will set your HP to 50...')
    assault.addoption('m4a1', '[√] FN4700 Assault Rifle (M4A1 Carbine)')
    assault.addoption('famas', '[√] FN2000 Assault Rifle (FAMAS)')
    assault.addoption('mp5navy', '[√] FN Navy 3200 Sub Machine Gun  (MP5Navy)')
    assault.addoption('m3', '[√] Remington 870 MCS Shotgun (M3)')
    assault.addoption('xm1014', '[√] FN303 Less Lethal Launcher (XM1014)')
    support = easymenu('hidden_support', '_popup_choice', Support)
    support.settitle('[√] Support')
    support.addoption('mp5navy', '[√] FN Navy 3200 Sub Machine Gun  (MP5Navy)')
    support.addoption('tmp', '[√] FN Tactial Machine Gun  (TMP)')
    support.addoption('xm1014', '[√] FN303 Less Lethal Launcher (XM1014)')
    sec = easymenu('hidden_secondary', '_popup_choice', Sec)
    sec.addoption('fiveseven', '[√] FN FiveSeven Pistol (Fiveseven)')
    sec.addoption('p228', '[√] FNP-9 Pistol (P228)')
    addition = easymenu('hidden_addition', '_popup_choice', Addition)
    addition.settitle('Choose an Additional')
    addition.setdescription('High-Explosive Grenade will give you the\nLight Amplification Goggles (NVGs) too.')
    addition.addoption('nvgs', '[√] Light Amplification Goggles (NVGs)')
    addition.addoption('hegrenade', '[√] High-Explosive Grenade')
    addition.addoption('flashbang', '[√] Flash-Bang')
    for userid in es.getUseridList():
        uid = str(userid)
        player[uid] = Player(uid)
    if not es.exists('saycommand', '!class'):
        es.regsaycmd('!class', 'hidden/getclass')
    es.lightstyle(0, config.getFile()['general']['dark_mode'].replace('0', 'g').replace('1', 'b').replace('2', 'a'))
    botsettings()
    downloads()

def unload():
    choose.delete()
    sec.delete()
    assault.delete()
    support.delete()
    addition.delete()
    es.unregsaycmd('!class')
    for userid in player:
        player[userid].funcs('enable')
    player.clear()
    gamethread.cancelDelayed('scary')

def es_map_start(ev):
    es.lightstyle(0, config.getFile()['general']['dark_mode'].replace('0', 'g').replace('1', 'b').replace('2', 'a'))
    botsettings()
    downloads()
    gamethread.cancelDelayed('scary')

def botsettings():
    es.ServerVar('mp_autoteambalance').set(0)
    es.ServerVar('mp_limitteam').set(0)
    es.ServerVar('bot_quota').set(4)
    es.ServerVar('bot_quota_mode').set('fill')
    es.ServerVar('bot_auto_vacate').set(1)
    es.ServerVar('bot_join_after_player').set(1)
    es.ServerVar('bot_join_team').set('any')

def downloads():
    slist = []
    for x in sounds:
        slist.append('IRIS-617%s.mp3' % x)
        slist.append('617-%s.mp3' % x)
    for x in start_sounds:
        slist.append('IRIS-%s.wav' % x)
    for x in death_hidden:
        slist.append('617-%s.mp3' % x)
    for x in scary_sounds:
        slist.append('617-%s.mp3' % x)
    for x in answers_iris:
        slist.append('IRIS-%s.wav' % x)
    for x in death_iris:
        slist.append('IRIS-%s.wav' % x)
    for x in end_sounds:
        slist.append('IRIS-%s.wav' % x)
    for x in slist:
        es.stringtable('downloadables', 'sound/hidden/%s' % x)
    for x in ('iris.vmt', 'iris.vtf'):
        es.stringtable('downloadables', 'materials/overlays/%s' % x)

def getclass():
    player[str(es.getcmduserid())].getClass()

def Choose(userid, choice, popupid):
    player[str(userid)]._choose(choice)

def Assault(userid, choice, popupid):
    player[str(userid)]._assault(choice)

def Support(userid, choice, popupid):
    player[str(userid)]._support(choice)

def Sec(userid, choice, popupid):
    player[str(userid)]._sec(choice)

def Addition(userid, choice, popupid):
    player[str(userid)]._addition(choice)

def round_start(ev):
    es.msg('#multi', '#green[#lightgreenES Hidden#green] #lightgreen- #greenMISSION EXECUTE #lightgreen-')
    es.lightstyle(0, config.getFile()['general']['dark_mode'].replace('0', 'g').replace('1', 'b').replace('2', 'a'))
    for userid in es.getUseridList():
        if es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
            spawnPlayer(userid)

def round_freeze_end(ev):
    for userid in es.getUseridList():
        if es.getplayerteam(userid) == 3:
            es.centertell(userid, '617 has been spotted in this sector - MOVE OUT!')
            gamethread.delayed(1, es.centertell, (userid, '617 has been spotted in this sector - MOVE OUT!'))
            gamethread.delayed(2, es.centertell, (userid, '617 has been spotted in this sector - MOVE OUT!'))
        elif es.getplayerteam(userid) == 2:
            es.centertell(userid, 'You are the Hidden - Rescue yourself!')
            gamethread.delayed(1, es.centertell, (userid, 'You are the Hidden - Rescue yourself!'))
            gamethread.delayed(2, es.centertell, (userid, 'You are the Hidden - Rescue yourself!'))
    gamethread.delayed(5, es.cexec_all, ('play', 'hidden/IRIS-%s' % rChoice(start_sounds)))

def player_activate(ev):
    userid = ev['userid']
    if not player.has_key(userid):
        player[userid] = Player(userid)

def player_spawn(ev):
    userid = ev['userid']
    team = int(ev['es_userteam'])
    if team > 1 and player.has_key(userid):
        player[userid].spawn(team)

def item_pickup(ev):
    userid = ev['userid']
    if ev['es_userteam'] == '2' and ev['item'] != 'knife' and player.has_key(userid):
        player[userid].strip()

def player_death(ev):
    player[ev['attacker']].death(ev['userid'])

def round_end(ev):
    for userid in es.getUseridList():
        userid = str(userid)
        if player.has_key(userid):
            player[userid].endRound(int(ev['winner']))

def player_disconnect(ev):
    del player[ev['userid']]
